// mainwnd.h : interface of the CMainWnd class
//
/////////////////////////////////////////////////////////////////////////////

class CMainWnd : public CFrameWnd
{
public: // create from serialization only
	CMainWnd();
	//DECLARE_DYNCREATE(CMainWnd)

// Attributes
public:

// Operations
public:

// Implementation
public:

	virtual ~CMainWnd();
#ifdef _DEBUG
	virtual	void AssertValid() const;
	virtual	void Dump(CDumpContext& dc) const;
#endif


// Generated message map functions
protected:
	//{{AFX_MSG(CMainWnd)
	afx_msg void OnSysColorChange();
	afx_msg void OnMazeNew();
	afx_msg void OnPaint();
	afx_msg void OnMazeShow();
	afx_msg void OnUpdateMazeShow(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMove(int x, int y);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPrint();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnAutoPrint();
	afx_msg void OnMazeCopy();
	afx_msg void OnFileSave();
	afx_msg void OnFileLoad();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMazeCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMazePrint(CCmdUI* pCmdUI);
	afx_msg void OnHelpContents();
	afx_msg void OnHelpOnHelp();
	afx_msg void OnMazePrintSetup();
	afx_msg void OnUpdateShowTrack(CCmdUI* pCmdUI);
	afx_msg void OnShowTrack();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	
public:
	CPrintDialog  PrintDialog ; // print setup dialog box

};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CMazeNew dialog

class CMazeNew : public CDialog
{
// Construction
public:
	CMazeNew(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMazeNew)
	enum { IDD = IDD_MAZENEW };
	CEdit	m_ctlWidth;
	CEdit	m_ctlHeight;
	int m_Height ;
	int m_Width ;
	BOOL	m_BeepOnComplete;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CMazeNew)
	virtual void OnOK();
	afx_msg void OnClickedHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CPrintCancelDlg dialog

class CPrintCancelDlg : public CDialog
{
// Construction
public:
	BOOL Create(UINT TemplateName)
		{ return CDialog::Create(TemplateName) ; }
	CPrintCancelDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPrintCancelDlg)
	enum { IDD = IDD_PRINTCANCEL };
	CStatic	m_PrinterName;
	CStatic	m_Msg;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CPrintCancelDlg)
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CMyPrintDialog dialog

class CMyPrintDialog : public CDialog
{
// Construction
public:
	CMyPrintDialog(CWnd* pParent = NULL);	// standard constructor
	virtual BOOL OnInitDialog() ;

// Dialog Data
	//{{AFX_DATA(CMyPrintDialog)
	enum { IDD = IDD_PRINTDIALOG };
	CEdit	m_ctlPrintCopies;
	CStatic	m_PrintName;
	CButton	m_ctlPrintTrack;
	CButton	m_ctlPrintSolution;
	BOOL	m_PrintSolution;
	BOOL	m_PrintTrack;
	UINT	m_PrintCopies;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CMyPrintDialog)
	afx_msg void OnClickedPrintPrinter();
	afx_msg void OnClickedPrintMargins();
	afx_msg void OnClickedHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CPrintMargins dialog

class CPrintMargins : public CDialog
{
// Construction
public:
	CPrintMargins(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPrintMargins)
	enum { IDD = IDD_MAZEPRINTMARGINS };
	CString	m_sMarginBottom;
	CString	m_sMarginLeft;
	CString	m_sMarginRight;
	CString	m_sMarginTop;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CPrintMargins)
	afx_msg void OnClickedHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CAutoPrintDialog dialog

class CAutoPrintDialog : public CDialog
{
// Construction
public:
	CAutoPrintDialog(CWnd* pParent = NULL);	// standard constructor
	virtual BOOL OnInitDialog() ;

// Dialog Data
	//{{AFX_DATA(CAutoPrintDialog)
	enum { IDD = IDD_APRINTDIALOG };
	CEdit	m_ctlMazes;
	CStatic	m_PrintName;
	UINT	m_Blank;
	UINT	m_Mazes;
	UINT	m_Solution;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CAutoPrintDialog)
	afx_msg void OnClickedPrintPrinter();
	afx_msg void OnClickedPrintMargins();
	afx_msg void OnClickedHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CCalcCancel dialog

class CCalcCancel : public CDialog
{
// Construction
public:
	BOOL Create(UINT TemplateName)
		{ return CDialog::Create(TemplateName) ; }
	CCalcCancel(CWnd* pParent = NULL);	// standard constructor
	virtual BOOL OnInitDialog() ;
	int ThisIcon ;
	void Animate() ;

// Dialog Data
	//{{AFX_DATA(CCalcCancel)
	enum { IDD = IDD_CALCCANCEL };
	CStatic	m_Img;
	CStatic	m_Msg;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CCalcCancel)
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
