//////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////// 
// 
// Simple Maze Calculation Subroutines
// This is experimental and unfinished code, the final version is MAZEGEN.CPP

ERROR__This_should_not_be_compiled___Experimental_code

#include "stdafx.h"
#include "mazeing.h"

#include "mainwnd.h"

#define extern			// we want to allocate variables in this file
#include "globals.h"


/*
Generating mazes...

The algorithm is quite simple, it is the frills which has made it all complicated.

How to make a maze:

	Pick a cell on an existing path.  Pick a cell at random next to it which is not
	already part of a path, move to it and repeat this step for the new cell.  When you
	cannot proceed any further (all cells around the current cell are part of paths)
	then you are finished with that path.
	
	You are finished generating the maze when you have tried starting a path from all
	cells which are part of a path (which will eventually be all cells in the matrix).
	
	To start you need to select one cell and declare that is is a path, from then on the
	algorithm will generate a maze with only one path from any cell to any other.  All
	you do now is select at random an entrance and exit.

This maze generation routine is mased on this, the generation routine used in Mazeing is
more complicated...  see MAZEGEN.CPP
*/



// functions
int Recurse() ;
void InitCells() ;


// globals
unsigned char FAR *Cur ;
HGLOBAL hCur, hTPathX, hTPathY ;
HGLOBAL hPathX, hPathY, hCell ;
int x, y ;
unsigned int c, cnt, dir ;
int tx, ty ;
int newd ;
int restarts ;
int FAR *px ;
int FAR *py ;
int d, maxd ;
int subs ;
int tries = 50;
int oldd ;
unsigned long retries ;
int MainSidePaths, i ;
// debugging info
unsigned long toosmall, toobig, fullrestart ;
int occupied ;			// loaded with a constant to test if next cell used
char buf[40] ;			// used to create dialog boxe messages
unsigned long NextTime ;




void GetSolution(int StartX, int EndX)
{
	register int x = StartX ;
	register int y = 0 ;
	register int d = -1 ;
	register int t = 3 ;

 recurse:
	d++ ;
	//TRACE("%d   %d x %d\r\n", d,x,y) ;
	PathX[d] = x ; PathY[d] = y ;
	if(x == EndX && y == yd - 2) {
		PathLength = d++ ;
		PathX[d] = x ; PathY[d] = y-1 ;
		return ;
		}
	Cur[d] = 0 ;
 loop:
	switch(Cur[d]) {
 		case 0:	// left
 				if(t != 2 && !(CELL(x, y) & LFT)) {
 					x-- ;
 					t = 0 ;
 					goto recurse ; 
 				    }
 				break ;
 		case 1:	// up
 				if(t != 3 && !(CELL(x, y) & TOP)) {
 					y-- ;
 					t = 1 ;
 					goto recurse ; 
 				    }
 				break ;
 		case 2:	// right
 				if(t != 0 && !(CELL(x+1, y) & LFT)) {
 					x++ ;
 					t = 2 ;
 					goto recurse ; 
 				    }
 				break ;
 		case 3:	// down
 				if(t != 1 && !(CELL(x, y+1) & TOP)) {
 					y++ ;
 					t = 3 ;
 					goto recurse ; 
 				    }
 				break ;
 		}
 	if(++Cur[d] > 3) { d-- ; ++Cur[d] ; x = PathX[d] ; y = PathY[d] ; t = d?Cur[d-1]:3 ;}
 	goto loop ;
}




// This is called from CMazeingApp::OnIdle when there is some idle time
// It is implemented as a state engine, when processing is completed
// in one state MazeGenMode is incremented and processing moves on.
// At the completition of each step control is returned to Windows
// for further processing.
int MazeOnIdle()
{

    // if displaying the "Calculating Made" dialog animate the graphic
	if(ValidCalcCancelDlg && NextTime <= GetTickCount()) {
		CalcCancel.Animate() ;
		NextTime = GetTickCount() + 300L ;		// next animation in 300ms
		}
		
	switch(MazeGenMode) {
		case 0:	// setup for generating the maze
				MouseOnTrack = MouseIndex = TrackLength = ValidMaze = 0 ;
			 	MainSidePaths = 0 ;
			 	NextTime = ProgressCnt = retries = 0 ;
				fullrestart = toosmall = retries = toobig = 0 ;
				++AutoPrintCount ;
				if(!AllocateArrays()) {
					AutoPrintMazes = 0 ;
					MazeGenMode = MAX_GEN_MODE + 1 ;
					return 0 ;
					}
				pMainWnd->EnableWindow(FALSE) ;
				CalcCancel.Create(IDD_CALCCANCEL) ;
				ValidCalcCancelDlg = 1 ;
				if(AutoPrintMazes)
					wsprintf(buf, "#%u", AutoPrintCount) ;
				else
					wsprintf(buf, "%d x %d", xd-1, yd-1) ;
				CalcCancel.m_Msg.SetWindowText(buf) ;
				AbortPrint = 0;
				LockArrays() ;
				occupied = USED | VISITED ;
				TRACE("--- x = %u   y = %u ----\r\n", xd, yd) ;
				MazeGenMode++ ;
				return 1 ;
				
		case 1:	// restart position if we need to totally restart the maze gen
				InitCells() ;			// init the cell array (fill in all walls)
			 	maxd = d = restarts = 0 ;
			 	fullrestart++ ;
			 	px = PathX ;  py = PathY ;  subs = 0 ;
			 	x = (unsigned)(((long)rand() * ((long)xd/3)) / RAND_MAX) + xd/3;	// select starting cell
				y = 0 ;
				MazeGenMode++ ;
				return 1 ;
				
		case 2:	// process one interation of the primary path generation
		/*		ProgressCnt++ ;
				switch(Recurse()) {
					case 0:	return 1 ;		// still calculating
					case 1:	MazeGenMode-- ;	// restart path generation
							return 1 ;                                
					case 2:	MazeGenMode++ ;	// success, finished
							return 1 ;
				    }
				AbortMsg("Internal error: MazeOnIdle case 2") ;
		*/
				MazeGenMode++ ;
				return 1 ;
				                      
		case 3:	// cleanup from generating the primary path and setup for generating the side paths
		/*		PathLength = maxd ;
				MainSidePaths = maxd / 4 ;	// test 1 in 4 cells of the main path for side path gen
				CELL(x, 0) |= ENTRY ;
				CELL(x, 0) &= (~TOP) ;
				TRACE("PRIMARY PATH  too small: %lu, retries: %lu, restart: %lu, path len: %d\r\n",
					toosmall,retries, fullrestart - 1U, PathLength) ; 
		*/		occupied = USED ;
				px = TPathX ;  py = TPathY ;  subs = 1 ;
				CELL(xd/2, yd/2) |= USED | TODO ;	// starting cell
				MazeGenMode++ ;
				return 1 ;
				
		case 4:	// process a number of side path generation steps
				//if(MainSidePaths--) {
				//	// for a start pick the main path to start side paths, this adds extra complexity
				//	i = (unsigned)(((long)rand() * (long)PathLength) / (long)RAND_MAX) ;
				//	x = PathX[i] ; y = PathY[i] ;
				//	}
				//else {
					// then pick a side path from anywhere
					x = (unsigned)(((long)rand() * (long)xd-2) / (long)RAND_MAX) ;
					y = (unsigned)(((long)rand() * (long)yd-2) / (long)RAND_MAX) ;
				//	}
				for(cnt = xd*yd ; cnt ; cnt--)
					if(CELL(x, y) & TODO) {
						// first do a quick check to see if this cell is surrounded
						// by used cells.  if so clear the toto otherwise process
	 					if((x == 0 || (CELL(x-1, y) & USED)) &&
	 									(y == 0 || (CELL(x, y-1) & USED)) &&
	 									(x == xd - 2 || (CELL(x+1, y) & USED)) &&
	 									(y >= d - 2 || (CELL(x, y+1) & USED))) {
							CELL(x, y) &= (~TODO) ;
							if(y++ == yd-1) {
								y = 0 ;
								if(x++ == xd-1)
									x = 0 ;
								}
							continue ;
							}
					 	maxd = d = restarts = 0 ;
						MazeGenMode++ ;
						return 1 ;
						}
					else
						if(y++ == yd-1) {
							y = 0 ;
							if(x++ == xd-1)
								x = 0 ;
							}     
				
				MazeGenMode += 2 ; // no more cells "to do" so skip to the last state
				return 1 ;
				
		case 5:	// process one interation of generating this side path 
				ProgressCnt++ ;
				switch(Recurse()) {
					case 0:	return 1 ;		// still calculating
					case 1:	MazeGenMode-- ;	// restart path generation
							return 1 ;                                
					case 2:	MazeGenMode-- ;	// success, go back for more
							CELL(x, y) &= (~TODO) ;
							return 1 ;
				    }
				AbortMsg("Internal error: MazeOnIdle case 5") ;

		case 6:	// cleanup
			 	x = (unsigned)(((long)rand() * ((long)xd/3)) / RAND_MAX) + xd/3;	// select entry cell
				CELL(x, 0) |= ENTRY ;
				CELL(x, 0) &= (~TOP) ;
			 	y = (unsigned)(((long)rand() * ((long)xd/3)) / RAND_MAX) + xd/3;	// select exit cell
				CELL(y, yd-1) |= ENTRY ;
				CELL(y, yd-1) &= (~TOP) ;
    			StartTime = GetTickCount() ;
				GetSolution(x,y) ;
				TRACE("Time: %ld msec\r\n", (GetTickCount()-StartTime)) ;
				UnLockArrays() ;
				ValidMaze = 1 ;
				pMainWnd->EnableWindow(TRUE) ;
				if(ValidCalcCancelDlg) CalcCancel.DestroyWindow() ;
				ValidCalcCancelDlg = 0 ;
				MazeGenMode++ ;
				//TRACE("ratio = %f\r\n", (float)((float)ProgressCnt/(float)((xd-1)*(yd-1)))) ;
				pMainWnd->Invalidate(TRUE) ;
				return 1 ;
				
		case 7:	// Auto print the blank copy (if required)
				if(AutoPrintMazes && AutoPrintBlank) {
					wsprintf(buf, "#%u", AutoPrintCount) ;
					if(!DoPrintMaze(AutoPrintBlank, 0, 0, buf)) {
						AutoPrintMazes = 0 ;
						MazeGenMode = MAX_GEN_MODE + 1 ;
						return 0 ;
						}
					}
				MazeGenMode++ ;
				return 1 ;
				
		case 8:	// Auto print the solved copy (if required)
				if(AutoPrintMazes && AutoPrintSolution) {
					wsprintf(buf, "#%u (Solution)", AutoPrintCount) ;
					if(!DoPrintMaze(AutoPrintSolution, 1, 0, buf)) {
						AutoPrintMazes = 0 ;
						MazeGenMode = MAX_GEN_MODE + 1 ;
						return 0 ;
						}
					}
				MazeGenMode++ ;
				return 1 ;


		case 9:	// Re trigger another maze if more auto printing required
				// WARNING: ensure that MAX_GEN_MODE is set to the same
				//			value as the target for the last case statement.
				if(AutoPrintMazes)
					if(--AutoPrintMazes) {
					    // trigger the generation of a new maze
					    ShowSolution = 0 ;
						MazeGenMode = 0 ;
						ValidMaze = 0 ;
						pMainWnd->Invalidate(TRUE) ;
						return 1 ;
						}
				MazeGenMode++ ;
				if(BeepOnComplete) MessageBeep(MB_OK) ;
				return 0 ;
				
		}
	
	return 0 ;
}






                                          
// starting point when recursing down the path
int Recurse()
//	returns	0 = still calculating
//			1 = failure, could not generate a path
//			2 = success, finished a path
{
    // maximum path length is half the number of cells
	if((unsigned)d >= (unsigned)((unsigned)(xd+1)*(unsigned)(yd+1)/(unsigned)2))
		return 1 ;
		
	// first test if we are actually making progress 		
	if(tries-- <= 0) {
		tries = TEST_INTERVAL ;
		// if not making progress search for path nearest bottom and restart from there
		if(!subs && (d < oldd || !(d > oldd + MIN_PROGRESS))) {
			retries++ ;
		  	if(++restarts >= RESTART_STEP || d < 5) return 1 ; // exit if too many
			CELL(x, y) &= (~USED) ;		// clear current cell
			newd = 0 ; y = 0 ;
			for(oldd = d-1 ; oldd ; oldd--) // scan for spot nearest the bottom
				if(py[oldd] > y) {newd = oldd ; y = py[oldd] ; x = px[oldd] ;}
			if(newd++ == 0) return 1 ;
		 	while(--d > newd)				// clear everything to there
	 			CELL(px[d], py[d]) &= (~USED) ;
			CELL(px[d], py[d]) &= (~USED) ;
			oldd = d ;
		 	goto return_false ;
		 	}
	 	oldd = d ;
		}

 	c = 0 ;		// set details of our current position to 0
 	
 // arrive here if testing of a particular direction fails
 skipit:
 	if((c & (UP|RT|DN|LT)) == (UP|RT|DN|LT))	// if tried every direction
 		if(subs)
 			goto markit ;
 		else 
 			goto return_false ;

 // loop back point if direction already tested
 retrydir:

	// select a direction to test
 	dir = (rand() & DIR) ;
	
 	switch(dir) {
 		case 0:	if(!(c & LT)) {		// left
 					c |= LT ;
 					if(x == 0 || (CELL(x-1, y) & occupied)) goto skipit ;
 					tx = -1 ; ty = 0 ;
 					break ;
 					}
 				else
 					goto retrydir ;
 					
 		case 1:	if(!(c & UP)) {		// up
 					c |= UP ;
 					if(y == 0 || (CELL(x, y-1) & occupied)) goto skipit ;
 					tx = 0 ; ty = -1 ;
 					break ;
 					}
 				else
 					goto retrydir ;
 					
 		case 2:	if(!(c & RT)) {		// right
 					c |= RT ;
 					if(x == xd - 2 || (CELL(x+1, y) & occupied)) goto skipit ;
 					tx = 1 ; ty = 0 ;
 					break ;
 					}
 				else
 					goto retrydir ;
 					
 		case 3:	if(!(c & DN)) {		// down
 					c |= DN ;
 					if(y >= (yd - 2))
 						if(subs)
 							goto skipit ;
 						else {	//in the main path and found the exit!!!
 							if((unsigned)d < yd*(xd/(10+toosmall))) {
 								toosmall++ ;	// not complex enough
								return 1 ;
 								}
 							CELL(x, y+1) |= ENTRY ;
						 	px[d] = x ; py[d] = y ;
 							maxd = d ;
 							goto remove_wall ;
 							}
 					if(CELL(x, y+1) & occupied) goto skipit ;
 					tx = 0 ; ty = 1 ;
 					break ;
 					}
 				else
 					goto retrydir ;
 		}
 		
 	// save variables for recursion
 	Cur[d] = c | dir ;
 	px[d] = x ; py[d] = y ;
 	
 	// recursively test the next step on the path
 	d++ ;
 	CELL(x, y) |= (USED | VISITED) ;
 	x += tx ; y += ty ;
 	return 0 ; // return to windows which will call us again when it is ready
 	
 	
 // returned from recursion with failure
 return_false:
 	if(d-- == 0) return 1 ;
 	c = (Cur[d] & (~DIR)) ; dir = (Cur[d] & DIR) ;
 	x = px[d] ;  y = py[d] ;
 	if(!(d == 0 && subs))
	 	CELL(x, y) &= (~USED) ;
	 goto skipit ;


 // returned from recursion with success
 return_true:
 	d-- ;
 	dir = (Cur[d] & DIR) ;
 	x = px[d] ;  y = py[d] ;

 // found a valid path... remove the wall
 remove_wall:
 	switch(dir) {
 		case 0:	CELL(x, y) &= (~LFT) ; break ;
 		case 1:	CELL(x, y) &= (~TOP) ; break ;
 		case 2:	CELL(x+1, y) &= (~LFT) ; break ;
 		case 3:	CELL(x, y+1) &= (~TOP) ; break ;
 		}
 	
 // mark the cell as used
 markit:
 	CELL(x, y) |= USED ;
	if(!(d == 0 && subs)) 	
	 	CELL(x, y) |= TODO ;
	if(d == 0)
		return 2 ;	// SUCESS!! Finished the path
	goto return_true ;	// go back up the recursion  
	
}





// initilise the cell table (ie. fill in all walls, clear entry and todo)
void InitCells()
{
	register int x, y ;

    // fill in the interior walls
	for(x = 0 ; x < xd - 1 ; x++)
		for(y = 0 ; y < yd - 1 ; y++)
			CELL(x, y) = TOP | LFT ;
	
	// fill in the right hand wall
	for(y = 0 ; y < yd - 1 ; y++)
		CELL(xd-1, y) = LFT ;
	
	// fill in the bottom wall	
	for(x = 0 ; x < xd - 1 ; x++)
		CELL(x, yd-1) = TOP ;
	
	// clear the far bottom right cell
	CELL(xd, -1) = 0 ;

}




///////////////////////////////////////////////////////////////////////////////
//  General routines


int AllocateArrays()
{
    const unsigned mazedims = ((unsigned)(xd+1)*(unsigned)(yd+1)) ;
    
	if(hCell != NULL) return 1 ;

    hCell = GlobalAlloc(GMEM_MOVEABLE, (unsigned)sizeof(unsigned char)*mazedims);
	if(hCell == NULL) goto AllocateErr ;
	
	hPathX = GlobalAlloc(GMEM_MOVEABLE, (unsigned)sizeof(unsigned int)*mazedims/1U);
	if(hPathX == NULL) goto AllocateErr ;
	
	hPathY = GlobalAlloc(GMEM_MOVEABLE, (unsigned)sizeof(unsigned int)*mazedims/1U);
	if(hPathY == NULL) goto AllocateErr ;

    hCur = GlobalAlloc(GMEM_MOVEABLE, (unsigned)sizeof(unsigned char)*mazedims/1U);
	if(hCur == NULL) goto AllocateErr ;
	
	hTPathX = GlobalAlloc(GMEM_MOVEABLE, (unsigned)sizeof(unsigned int)*mazedims/2U);
	if(hTPathX == NULL) goto AllocateErr ;
	
	hTPathY = GlobalAlloc(GMEM_MOVEABLE, (unsigned)sizeof(unsigned int)*mazedims/2U);
	if(hTPathY == NULL) goto AllocateErr ;

	return 1 ;

 AllocateErr:
	AbortMsg("Not enough memory\r\nMemory allocation failed");
    FreeArrays() ;
	return 0 ;
}




		
void LockArrays()
{

    Cell = (unsigned char FAR *)GlobalLock(hCell) ;
	if(Cell == NULL) goto LockErr ;
	
	PathX = (int FAR *)GlobalLock(hPathX) ;
	if(PathX == NULL) goto LockErr ;
	
	PathY = (int FAR *)GlobalLock(hPathY) ;
	if(PathY == NULL) goto LockErr ;
	
    Cur = (unsigned char FAR *)GlobalLock(hCur) ;
	if(Cur == NULL) goto LockErr ;
	
	TPathX = (int FAR *)GlobalLock(hTPathX) ;
	if(TPathX == NULL) goto LockErr ;
	
	TPathY = (int FAR *)GlobalLock(hTPathY) ;
	if(TPathY == NULL) goto LockErr ;
	
	return ;
	
LockErr:
		AbortMsg("Not enough memory\r\nMemory lock failed");
		UnLockArrays() ;
	    FreeArrays() ;
}





		
void UnLockArrays()
{
	if(GlobalUnlock(hCell) || GlobalUnlock(hPathX) || GlobalUnlock(hPathY)
		|| GlobalUnlock(hCur) || GlobalUnlock(hTPathX) || GlobalUnlock(hTPathY)) {
		AbortMsg("Internal error\r\nMemory unlock failed");
	    FreeArrays() ;
		}
}                                                                               





void FreeArrays()
{
	if(GlobalFree(hCell) || GlobalFree(hPathX) || GlobalFree(hPathY)
			|| GlobalFree(hCur) || GlobalFree(hTPathX) || GlobalFree(hTPathY))
		AbortMsg("Internal error\r\nMemory free failed");

	hCell = hPathX = hPathY = hCur = hTPathX = hPathY = NULL ;
	ValidMaze = 0 ;
}                                                                               





